%bcond_without doc 
%bcond_without check_mapping 

Summary:    OpenStack Neutron library
Name:       python-neutron-lib
Version:    3.1.2
Release:    1%{?dist}
License:    Apache-2.0
URL:        http://launchpad.net/neutron/
Source0:    https://tarballs.openstack.org/neutron-lib/neutron-lib-%{version}.tar.gz

BuildRequires:  python3-devel python3-pbr python3-pip python3-setuptools

BuildArch:  noarch

%description
This package provides OpenStack Neutron library shared by all Neutron sub-projects.

%package -n  python3-neutron-lib
Summary:    OpenStack Neutron library
# tests requires
BuildRequires: python3-keystoneauth1 python3-oslotest python3-stestr python3-testtools
BuildRequires: python3-osprofiler python3-pecan python3-six python3-oslo-policy
BuildRequires: python3-testscenarios python3-testresources python3-os-ken python3-os-traits
BuildRequires: python3-oslo-context python3-oslo-concurrency python3-oslo-db python3-oslo-i18n
BuildRequires: python3-oslo-log python3-oslo-utils python3-oslo-versionedobjects
BuildRequires: python3-oslo-service python3-fixtures python3-netaddr python3-setproctitle
BuildRequires: python3-importlib-metadata

Requires:   python3-pbr python3-keystoneauth1 >= 3.4.0 python3-netaddr >= 0.7.18
Requires:   python3-os-ken >= 0.3.0 python3-os-traits >= 0.9.0 python3-oslo-concurrency >= 3.26.0
Requires:   python3-oslo-config python3-oslo-context >= 2.19.2 python3-oslo-messaging >= 5.29.0
Requires:   python3-oslo-i18n >= 3.15.3 python3-oslo-log >= 3.36.0 python3-oslo-db >= 4.37.0
Requires:   python3-oslo-policy >= 1.30.0 python3-oslo-serialization >= 2.18.0
Requires:   python3-oslo-utils >= 3.33.0 python3-sqlalchemy >= 1.2.0 python3-setproctitle
Requires:   python3-stevedore python3-pecan >= 1.0.0 python3-oslo-versionedobjects >= 1.31.2
Requires:   python3-osprofiler >= 1.4.0 python3-oslo-service >= 1.24.0 python3-webob >= 1.7.1

%description -n python3-neutron-lib
This package provides OpenStack Neutron library shared by all Neutron sub-projects.


%package -n python3-neutron-lib-tests
Summary:    OpenStack Neutron library tests
Requires:   python3-neutron-lib = %{version}-%{release}

%description -n python3-neutron-lib-tests
This package provides the Neutron library test files.

%if 0%{?with_doc}
%package doc
Summary:    OpenStack Neutron library documentation

BuildRequires: python3-sphinx
BuildRequires: python3-openstackdocstheme

%description doc
This package provides the documentation for the OpenStack Neutron.
%endif

%prep
%autosetup -n neutron-lib-%{version} -p1
rm -rf *requirements.txt

%if %{with check_mapping}
# collections.Mapping stop working in Python 3.10
sed -i 's/collections.Mapping/collections.abc.Mapping/' neutron_lib/utils/helpers.py
%endif

%build
%{py3_build}

%if 0%{?with_doc}
export PYTHONPATH=.
sphinx-build-3 -b html doc/source doc/build/html
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%install
%{py3_install}

%check
%if %{with check_mapping}
rm -f ./neutron_lib/tests/unit/hacking/test_checks.py
export OS_TEST_PATH='./neutron_lib/tests/unit'
export PATH=$PATH:%{buildroot}/usr/bin
export PYTHONPATH=$PWD
PYTHON=python3 stestr --test-path $OS_TEST_PATH run
%endif

%files -n python3-neutron-lib
%license LICENSE
%{python3_sitelib}/neutron_lib
%{python3_sitelib}/neutron_lib-*.egg-info
%exclude %{python3_sitelib}/neutron_lib/tests

%files -n python3-neutron-lib-tests
%license LICENSE
%{python3_sitelib}/neutron_lib/tests

%if 0%{?with_doc}
%files doc
%license LICENSE
%doc doc/build/html README.rst
%endif

%changelog
* Wed Spe 27 2023 jackeyji <jackeyji@tencent.com> - 3.1.2-1
- upgrade to 3.1.2

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.1-4
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.1-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.1-2
- Rebuilt for OpenCloudOS Stream 23.05

* Mon Apr 17 2023 Wang Guodong <gordonwwang@tencent.com> - 2.10.1-1
- initial build
